'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _yosay = require('yosay');

var _yosay2 = _interopRequireDefault(_yosay);

var _ejs = require('ejs');

var _ejs2 = _interopRequireDefault(_ejs);

var _makeup = require('./makeup');

var _makeup2 = _interopRequireDefault(_makeup);

var _base = require('../../lib/base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AppGenerator = function (_BaseGenerator) {
  (0, _inherits3.default)(AppGenerator, _BaseGenerator);

  function AppGenerator() {
    var _ref;

    (0, _classCallCheck3.default)(this, AppGenerator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    // console.log('AppGenerator appname=', this.appname);
    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = AppGenerator.__proto__ || (0, _getPrototypeOf2.default)(AppGenerator)).call.apply(_ref, [this].concat(args)));

    _this.sourceRoot(_path2.default.join(__dirname, '../../../templates/app'));
    _this._setupMakeup();
    return _this;
  }

  (0, _createClass3.default)(AppGenerator, [{
    key: '_setupMakeup',
    value: function _setupMakeup() {
      var makeup = new _makeup2.default(this);
      makeup.applyConfig(this.config.getAll());
      makeup.applyOptions(this.options);
      makeup.applyDefaults(this.appname);
      this.makeup = makeup;
    }
  }, {
    key: 'prompting',
    value: function prompting() {
      var _this2 = this;

      if (!this.options['skip-welcome-message']) {
        // Have Yeoman greet the user.
        this.log((0, _yosay2.default)('Welcome to the marvelous WebpackVersatile generator!'));
      }

      var questions = this.makeup.getQuestions();
      return this.prompt(questions).then(function (answers) {
        _this2.makeup.putAnswers(answers);
      });
    }
  }, {
    key: 'configuring',
    value: function configuring() {
      this.config.set(this.makeup.getPermanetConfig());
      this.config.save();
    }
  }, {
    key: 'writing',
    value: function writing() {
      var templateConfig = this.makeup.getTemplateConfig();
      var dirs = templateConfig.dirs;

      var templateTransformer = {
        src: /^%(.*)/,
        tgt: '$1',
        fn: function fn(s) {
          return _ejs2.default.render(s, templateConfig);
        }
      };

      // this.log('copy project files');
      this._branchCopy({
        source: 'root',
        branches: templateConfig.use,
        transformers: [templateTransformer]
      });

      // this.log('copy src files');
      this._branchCopy({
        source: 'src',
        target: dirs.src,
        branches: templateConfig.use,
        transformers: [templateTransformer]
      });

      // this.log('copy test files');
      this._branchCopy({
        source: 'test',
        target: dirs.test,
        branches: templateConfig.use,
        transformers: [templateTransformer]
      });
    }
  }, {
    key: 'install',
    value: function install() {
      if (!this.options['skip-install']) {
        this.installDependencies();
      }
    }
  }]);
  return AppGenerator;
}(_base2.default);

exports.default = AppGenerator;