'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _minimatch = require('minimatch');

var _minimatch2 = _interopRequireDefault(_minimatch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BranchFinder = function () {
  function BranchFinder(srcBase, tgtBase, options) {
    (0, _classCallCheck3.default)(this, BranchFinder);

    this.srcBase = srcBase;
    this.tgtBase = tgtBase;
    options = options || {};
    this.pattern = options.pattern || '**/*';
    this.branches = options.branches || {};
    this.reBranch = options.reBranch || /^\.if-(\w+)(-no)?$/;
    this.op = options.op || this.dummyOp.bind(this);
    this.tgtRelalative = options.tgtRelalative || '';
    this.transformers = options.transformers || [];
  }

  (0, _createClass3.default)(BranchFinder, [{
    key: 'getTi',
    value: function getTi(srcName) {
      var tgtName = srcName;
      var transFns = [];
      for (var i = 0; i < this.transformers.length; i++) {
        var transformer = this.transformers[i];
        if (tgtName.match(transformer.src)) {
          tgtName = srcName.replace(transformer.src, transformer.tgt);
          if (transformer.fn) {
            transFns.push(transformer.fn);
          }
          srcName = tgtName;
        }
      }
      return {
        tgtName: tgtName,
        transFns: transFns
      };
    }
  }, {
    key: 'run',
    value: function run(src, tgt) {
      src = src || '';
      tgt = tgt || '';
      var names = _fs2.default.readdirSync(_path2.default.join(this.srcBase, src));
      for (var i = 0; i < names.length; i++) {
        var srcName = names[i];
        var srcNext = _path2.default.join(src, srcName);
        var srcPath = _path2.default.join(this.srcBase, srcNext);
        var srcStat = _fs2.default.statSync(srcPath);
        if (srcStat.isFile()) {
          if (srcName === '.unsupported') {
            var msg = _fs2.default.readFileSync(srcPath);
            throw new Error(msg);
          }
          var ti = this.getTi(srcName);
          var tgtName = ti.tgtName;
          // console.log '%s -> %s', srcName, tgtName

          var tgtOk = (0, _minimatch2.default)(_path2.default.join(tgt, tgtName), this.pattern, { dot: true });
          if (tgtOk) {
            var tgtPath = _path2.default.join(this.tgtBase, _path2.default.relative(this.tgtRelalative, tgt), tgtName);
            this.op(srcPath, tgtPath, ti.transFns);
          }
        } else if (srcStat.isDirectory()) {
          var m = srcName.match(this.reBranch);
          if (m) {
            var setName = m[1];
            var setNot = m[2];
            if (!!this.branches[setName] === !setNot) {
              this.run(srcNext, tgt);
            }
          } else {
            this.run(srcNext, _path2.default.join(tgt, srcName));
          }
        }
      }
    }
  }]);
  return BranchFinder;
}();

var _do_run = false;
if (_do_run) {
  var bf = new BranchFinder(__dirname + '/../app/templates', '/tmp/ho-srv', {
    branches: {
      backbone: true,
      requirejs: true
    },
    pattern: 'server/**/*',
    tgtRelalative: 'server',
    transformers: [{
      name: 'backup',
      src: /(.*)/,
      tgt: '$1.bak'
    }]
  });
  bf.run();
}

BranchFinder.prototype.dummyOp = function (srcPath, tgtPath) {
  // eslint-disable-next-line no-console
  console.log('op', srcPath, '->', tgtPath);
};

exports.default = BranchFinder;